<template>
    <div class="container">
        <MainMenu ref="menu" />
        <div class="header">
            <div class="headerIcon" @click="() => this.$refs.menu.open()">
                <md-icon class="md-size-2x">menu</md-icon>
                <img src="@/assets/todo.png" style="display: inline" />
            </div>
            <div class="headerText"><span class="md-display-2">{{$t('main.header')}}</span></div>
            <div class="headerButton">
                <MdButton class="md-icon-button md-raised md-primary" @click="addTodo()">+</MdButton>
                <MdTooltip>{{ $t("main.addTooltip") }}</MdTooltip>
            </div>
        </div>
        <div class="body">
            <MdProgressBar md-mode="indeterminate" v-if="$store.state.loading" />
            <template v-else>
                <Table
                        ref="table"
                        paginate
                        mark-sorted-column
                        mark-even-odd
                        @rowClicked="row => openDetails(row.id)"
                        :lang="$i18n.locale"
                        :rows="rows"
                        :row-key="(row) => row.id"
                        :absolute-layout="true"
                        header-class="todoHeader"
                >
                    <template slot-scope="{row}">
                        <TableColumn field="summary"
                                     sort
                                     :label="$t('main.summaryColumnHeader')"
                                     :row="row"
                                     @click="openDetails(row.id)"
                                     :tooltip="tooltip(row.summary)"
                                     class="summary-col"
                        />
                        <TableColumn field="description"
                                     :label="$t('main.descriptionColumnHeader')"
                                     sort
                                     :row="row"
                                     @click="openDetails(row.id)"
                                     :tooltip="tooltip(row.summary)"
                        />
                        <TableColumn field="subtasks"
                                     :label="$t('main.subTaskColumnHeader')"
                                     sort
                                     :value="row => row.subtasks.length"
                                     :row="row"
                                     :tooltip="tooltip(row.summary)"
                                     @click="openDetails(row.id)"
                                     class="subtasks-col"
                        />
                        <TableColumn :row="row"
                                     class="menu-col"
                        >
                            <RoutableMenu>
                                <template v-slot:button>
                                    <MenuIcon />
                                </template>
                                <MdMenuItem @click="deleteItem(row)">{{$t('main.deleteMenuItem')}}</MdMenuItem>
                                <MdMenuItem @click="openDetails(row.id)">{{$t('main.editMenuItem')}}</MdMenuItem>
                                <MdMenuItem @click="addSubtask(row)">{{$t('main.addSubTaskMenuOption')}}
                                </MdMenuItem>
                            </RoutableMenu>
                            <MdTooltip>{{menuTooltip(row)}}</MdTooltip>
                        </TableColumn>
                    </template>
                    <template v-slot:empty>
                        {{$t('main.noTodos')}}
                    </template>
                </Table>
            </template>
        </div>
    </div>
</template>

<script>
  import Vue from 'vue';
  import Table from './Table';
  import TableColumn from './Table/TableColumn.vue';
  import MenuIcon from 'vue-material-design-icons/Menu'
  import { MdProgress, MdContent, MdButton, MdList, MdDrawer } from 'vue-material/dist/components'
  import { confirm, alert, prompt, init as initPrompt } from './modals';
  import MdTooltip from './TouchDeviceDisabledTooltip';
  import i18n from '../i18n';
  import jsLogger from 'js-logger';
  import RoutableMenu from './RoutableMenu';
  import MainMenu from './MainMenu';
  import { addAfterEach, removeAfterEach } from '../router';

  const log = jsLogger.get('App');

  Vue.use(MdProgress);
  Vue.use(MdButton);
  Vue.use(MdContent);
  Vue.use(MdList);
  Vue.use(MdDrawer);

  export default {
    name: 'Todos',
    components: {
      Table,
      TableColumn,
      MdTooltip,
      RoutableMenu,
      MenuIcon,
      MainMenu
    },
    computed: {
      rows() {
        const { todos } = this.$store.state;
        log.info('todos: ' + todos.length);
        return todos;
      }
    },
    i18n,
    methods: {
      routeChanged(to, from) {
        const re = /\/todo\/(\w+)/;
        if(re.test(from.path) && to.path === '/'){
            const id = re.exec(from.path)[1].trim();
            log.info('dialog closed id', id);
          this.$refs.table.paginateHighlightAndScrollInto(id);
        }

      },
      openDetails(id) {
        const url = `/todo/${id}`;
        log.info('open ', url);
        this.$router.push(url);
      },
      tooltip(summary) {
        return this.$t('main.openDetailsTooltip', { summary });
      },
      menuTooltip({ summary }) {
        return this.$t('main.menuTooltip', { summary });
      },
      async deleteItem({ id, summary }) {
        await new Promise(res => setTimeout(res));
        const message = this.$t('main.deleteTodoPrompt', { summary });
        const okText = this.$t('main.deleteTodoPromptOkText', { summary });
        const ok = await confirm(this, { message, okText });
        if (!ok) return;
        this.$store.dispatch('deleteTodo', id);
      },
      async addSubtask({ id, summary }) {
        await new Promise(res => setTimeout(res));
        const message = this.$t('main.addSubTaskPrompt', { summary });
        const okText = this.$t('main.addSubTaskPromptOkText');
        const subTaskName = await prompt(this, { message, okText });
        if (!subTaskName) return;
        const todo = this.$store.state.todos.find(({ id: tid }) => tid === id);
        if (todo && todo.subtasks.find(({ name }) => name === subTaskName)) {
          const message = this.$t('subtasks.newSubtaskAleadyThere', { name: subTaskName });
          await alert(this, { message })
        } else {
          await this.$store.dispatch('addSubTaskToTodo', { id, name: subTaskName });
        }
      },
      async addTodo() {
        const message = this.$t('main.addTodo');
        const title = this.$t('main.addTodoTitle');
        const okText = this.$t('main.addTodoOkText');
        const summaryName = await prompt(this, { message, title, okText });
        if (!summaryName) return;
        if (this.$store.state.todos.find(({ summary }) => summaryName === summary)) {
          await alert(this, { message: `There is already a todo with that summary name, please choose another name` })
        } else {
          await this.$store.dispatch('addTodo', summaryName);
          const lastId = this.$store.state.lastAddedId;
          log.info("add todo id ", lastId);
          this.$refs.table.paginateHighlightAndScrollInto(lastId);
          this.openDetails(lastId);
        }
      }
    },
    mounted() {
      initPrompt(this);
      addAfterEach(this.routeChanged);
      this.$store.dispatch('load', this.$route.params.id);
    },
    destroyed() {
      removeAfterEach(this.routeChanged);
    }
  }
</script>
<style>
    @import '../assets/variables.css';
</style>
<style lang="scss">
    @import "~vue-material/dist/theme/engine";

    @include md-register-theme("default", (
            primary: #5086C0,
            accent: lightblue,
            fieldvariant: red, // error text
            light-background: lightgrey
    ));

    @import "~vue-material/dist/theme/all";
</style>
<style scoped>
    .container {
        display: flex;
        flex-direction: column;
        width: 100%;
        height: 100%;
    }

    .header {
        background-color: var(--todo-header-bg-color);
        flex: 1 auto;
        padding: 4px 10px;
        border-bottom: 4px solid var(--md-theme-default-accent);
        display: flex;
        align-items: center;
    }

    .headerIcon {
        flex: 100 36px;
        margin-right: 70px;
        cursor: pointer;
        display: flex;
        align-items: center;
    }

    .headerText {
        flex: 10000 1px;
    }

    .headerButton {
        flex: 1 auto;
    }

    .header * {
        color: white !important;
    }

    .body {
        flex: 10000 1px;
        position: relative;
        overflow-y: auto;
    }
</style>
<style>
    .summary-col {
        width: 25%;
    }

    .subtasks-col {
        width: 100px;
    }

    .menu-col {
        width: 73px;
        max-width: 1px;
    }

    .menu-col SVG {
        transform: scale(1.2);
    }

    .todoHeader {
        background-color: var(--md-theme-default-primary);
    }

    .todoHeader, .todoHeader DIV {
        color: white;
    }

    .gu {
        background-color: red;
    }

    @media only screen and (max-width: 600px) {
        .menu-col {
            display: none !important;
        }
    }
</style>
